package gov.usgs.earthquake.nshmp.data;

/**
 * Wrapper interface for xy-value data pairs.
 *
 * @author Peter Powers
 * @see XySequence
 */
public interface XyPoint {

  /**
   * Return the x-value of this point.
   * @return x
   */
  double x();

  /**
   * Return the y-value of this point.
   * @return y
   */
  double y();

  /**
   * Set the y-value of this point.
   * 
   * @param y the y-value to set
   * @throws UnsupportedOperationException if the point is derived from an
   *         immutable {@code XySequence}.
   */
  default void set(double y) {
    throw new UnsupportedOperationException();
  }

}
