package gov.usgs.earthquake.nshmp.tree;

import static com.google.common.base.Preconditions.checkArgument;
import static com.google.common.base.Preconditions.checkNotNull;
import static gov.usgs.earthquake.nshmp.data.DoubleData.checkWeight;

/* Basic logic tree branch. */
class RegularBranch<T> implements Branch<T> {

  private final String id;
  private final T value;
  private final double weight;

  RegularBranch(String id, T value, double weight) {
    checkNotNull(id);
    checkArgument(!id.trim().isEmpty(), "Empty branch id");
    this.id = id;
    this.value = value; // TODO reenable checkNotNull(value);
    this.weight = checkWeight(weight);
  }

  @Override
  public String id() {
    return id;
  }

  @Override
  public T value() {
    return value;
  }

  @Override
  public double weight() {
    return weight;
  }

  @Override
  public String toString() {
    return id + '[' + weight + ']';
  }

}
