package gov.usgs.earthquake.nshmp.tree;

import static com.google.common.base.Preconditions.checkState;

import com.google.common.collect.ImmutableList;

/* Skeletal logic tree builder. */
abstract class TreeBuilder<T> {

  ImmutableList.Builder<Branch<T>> branches;
  private boolean built = false;

  TreeBuilder() {
    branches = ImmutableList.builder();
  }

  LogicTree<T> build() {
    checkState(!built, "Single use builder");
    built = true;
    return new RegularTree<T>(branches.build());
  }
}
